import 'package:plotter/config/default_global_settings.dart';
import 'package:plotter/utils/tools.dart';

class GlobalSettings {
  String skin;
  String apiHost;

  GlobalSettings({
    required this.skin,
    required this.apiHost,
  });

  static String getSkinValueFromUnsafe(String skin) {
    if (DefaultGlobalSettings.allowedSkinValues.contains(skin)) {
      return skin;
    }

    return DefaultGlobalSettings.defaultSkinValue;
  }

  factory GlobalSettings.createDefault() {
    return GlobalSettings(
      skin: DefaultGlobalSettings.defaultSkinValue,
      apiHost: '',
    );
  }

  void dump() {
    printlog('$GlobalSettings:');
    printlog('  ${DefaultGlobalSettings.parameterCodeSkin}: $skin');
    printlog('  apiHost: $apiHost');
    printlog('');
  }

  @override
  String toString() {
    return '$GlobalSettings(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      DefaultGlobalSettings.parameterCodeSkin: skin,
      'apiHost': apiHost,
    };
  }
}
